talloc and tdb use the waf build now
[build-farm.git] / build_test.fns
1 #!/bin/sh -*- mode: shell-script; sh-indentation: 8; indent-tabs-mode: t; -*-
2
3 # build_farm -- distributed build/test architecture for samba, rsync, etc
4
5 # Copyright (C) 2001 by Andrew Tridgell <tridge@samba.org>
6 # Copyright (C) 2001 by Andrew Bartlett <abartlet@samba.org>
7 # Copyright (C) 2001, 2003 by Martin Pool <mbp@samba.org>
8
9 # default maximum runtime for any command
10 MAXTIME=12000
11 # default maximum memory size (100M) for any command
12 MAXMEM=100000
13 RUN_FROM_BUILD_FARM=yes
14 export RUN_FROM_BUILD_FARM
15
16 deptrees="";
17
18 build_test_fns_id='$Id$'
19
20 #############################
21 # build a signature of a tree, used to see if we
22 # need to rebuild 
23 sum_tree() {
24         sum_tree_test_root=$1
25         sum_tree_tree=$2
26         sum_tree_sum=$3
27         sum_tree_scm=$4
28         find $sum_tree_test_root/$sum_tree_tree -type f -print | grep -v version.h | sort | xargs sum > $sum_tree_sum
29         sum build_test build_test.fns >> $sum_tree_sum
30
31         if [ -f "$host.fns" ]; then
32             sum $host.fns >> $sum_tree_sum
33         else
34             sum generic.fns >> $sum_tree_sum
35         fi
36
37         if [ -f "$test_root/$tree.$scm" ]; then
38             sum "$test_root/$tree.$scm" >> $sum_tree_sum
39         fi
40
41         for d in $deptrees; do
42             dscm=`choose_scm "$d"`
43             if [ -f "$test_root/$d.$dscm" ]; then
44                 sum "$test_root/$d.$dscm" >> $sum_tree_sum
45             fi
46         done
47 }
48
49 #############################
50 # send the logs to the master site
51 send_logs() {
52         if [ "$nologreturn" = "yes" ]; then
53                 echo "skipping log transfer"
54         else
55                 log="$1"
56                 err="$2"
57                 shift
58                 shift
59                 chmod 0644 "$log" "$err"
60
61                 # xargs -i is implemented differently or not at all.
62                 # GNU xargs did not implement "-I" until 4.2.9:
63                 xargs --version 2>&1 | grep "^GNU xargs" > /dev/null
64                 status=$?
65                 if [ x"$status" = x"0" ]; then
66                         XARGS_IS_GNU=yes
67                 fi
68
69                 if [ x"$XARGS_IS_GNU" = x"yes" ]; then
70                         XARGS_I="xargs -i"
71                 else
72                         XARGS_I="xargs -I '{}'"
73                 fi
74
75                 find $log -size +40000 | $XARGS_I sh -c 'dd if={} bs=1024 count=20000 of={}.tmp && mv {}.tmp {} &&  echo "\n***LOG TRUNCATED***" >> {}'
76                 find $err -size +40000 | $XARGS_I sh -c 'dd if={} bs=1024 count=20000 of={}.tmp && mv {}.tmp {} &&  echo "\n***LOG TRUNCATED***" >> {}'
77
78                 rsync $* -c -q --password-file=.password -z --timeout=200 \
79                     "$log" "$err" $host@build.samba.org::build_farm_data/
80         fi
81 }
82
83 #############################
84 # send the logs when they haven't changed
85 # the aim is to just update the servers timestamp.
86 # sending with a very large rsync block size does this
87 # with minimal network traffic
88 send_logs_skip() {
89     touch "$1" "$2"
90     send_logs "$1" "$2" -B 10000000
91 }
92
93 ############################
94 # fetch the latest copy of the tree
95 fetch_tree() {
96         if [ "$norsync" = "yes" ]; then
97                 echo "skipping tree transfer"
98         else
99                 fetchtree=$1
100                 if rsync --exclude=autom4te.cache/ --exclude=.svn/ --exclude=.git/ \
101                         --delete-excluded -q --partial --timeout=200 -ctrlpz --delete --ignore-errors \
102                         samba.org::ftp/unpacked/$fetchtree/ $test_root/$fetchtree; then
103                         echo "transferred $fetchtree OK"
104                 else
105                         echo "transfer of $fetchtree failed code $?"
106                         return 1
107                 fi
108         fi
109         return 0
110 }
111
112 ############################
113 # fetch the latest copy of the rev meta info
114 fetch_revinfo() {
115     tree=$1
116     scm=$2
117
118     test -z "$scm" && return 1
119     test x"$scm" = x"unknown" && return 1
120     test x"$scm" = x"cvs" && return 1
121
122     if [ "$norsync" = "yes" ]; then
123         echo "skipping .revinfo.$scm transfer"
124     else
125         if [ -r $test_root/$tree.$scm ]; then
126                 rm -f $test_root/$tree.$scm.old
127             mv $test_root/$tree.$scm $test_root/$tree.$scm.old
128         fi
129         rsync -q --timeout=200 -clz --ignore-errors \
130             samba.org::ftp/unpacked/$tree/.revinfo.$scm $test_root/$tree.$scm
131     fi
132     if [ -r $test_root/$tree.$scm ]; then
133         return 0;
134     fi
135     return 1
136 }
137
138 ############################
139 # choose the scm that is used for the given project
140 choose_scm() {
141         tree=$1
142
143         case "$tree" in
144                 samba* | rsync | libreplace | talloc | tdb | ldb | pidl | ccache)
145                         echo "git"
146                         return 0
147                 ;;
148         esac
149
150         echo "svn"
151         return 0
152 }
153
154 locknesting=0
155
156 ############################
157 # grab a lock file. Not atomic, but close :)
158 # tries to cope with NFS
159 lock_file() {
160         if [ -z "$lock_root" ]; then
161           lock_root=`pwd`;
162         fi
163         lckf="$lock_root/$1"
164         machine=`cat "$lckf" 2> /dev/null | cut -d: -f1`
165         pid=`cat "$lckf" 2> /dev/null | cut -d: -f2`
166
167         if [ "$pid" = "$$" ]; then
168             locknesting=`expr $locknesting + 1`
169             echo "lock nesting now $locknesting"
170             return 0
171         fi
172
173         if test -f "$lckf"; then
174             test $machine = $host || {
175                 echo "lock file $lckf is valid for other machine $machine"
176                 return 1                 
177             }
178             kill -0 $pid && {
179                 echo "lock file $lckf is valid for process $pid"
180                 return 1
181             }
182             echo "stale lock file $lckf for $machine:$pid"
183             cat "$lckf"
184             /bin/rm -f "$lckf"
185         fi
186         echo "$host:$$" > "$lckf"
187         return 0
188 }
189
190 ############################
191 # unlock a lock file
192 unlock_file() {
193         if [ -z "$lock_root" ]; then
194           lock_root=`pwd`;
195         fi
196         if [ "$locknesting" != "0" ]; then
197             locknesting=`expr $locknesting - 1`
198             echo "lock nesting now $locknesting"
199         else 
200             lckf="$lock_root/$1"
201             /bin/rm -f "$lckf"
202         fi
203 }
204
205 ############################
206 # run make, and print trace
207 do_make() {
208
209   if [ x"$MAKE" = x ] 
210   then
211     MAKE=make
212   fi 
213
214   MMTIME=$MAXTIME
215   # some trees don't need as much time
216   case "$tree" in
217         rsync | tdb | talloc | libreplace | ccache)
218           if [ "$compiler" != "checker" ]; then
219               MMTIME=`expr $MMTIME / 5`
220           fi
221           ;;
222   esac
223   
224     
225   for t in $*; do
226     if [ x"$BUILD_FARM_NUM_JOBS" = x ]; then
227       echo "$MAKE $t"
228       ./timelimit $MMTIME "$MAKE" "$t"
229       status=$?
230     else
231       # we can parallelize everything and all targets
232       if [ x"$t" = xeverything ] || [ x"$t" = xall]; then
233         echo "$MAKE" "-j$BUILD_FARM_NUM_JOBS"  "$t"
234         ./timelimit $MMTIME "$MAKE" "-j$BUILD_FARM_NUM_JOBS"  "$t"
235         status=$?
236       else
237         echo "$MAKE $t"
238         ./timelimit $MMTIME "$MAKE" "$t"
239         status=$?
240       fi
241     fi
242
243     if [ $status != 0 ]; then
244       return $status;
245     fi
246
247   done
248
249   return 0
250 }      
251
252 ############################
253 # configure the tree
254 action_configure() {
255         if [ ! -x $srcdir/configure ]; then
256             ls -l $srcdir/configure
257             echo "$srcdir/configure is missing"
258             cstatus=255
259             echo "CONFIGURE STATUS: $cstatus"
260             return $cstatus;
261         fi
262         echo "CFLAGS=$CFLAGS"
263         echo configure options: $config_and_prefix
264         echo CC="$CCACHE $compiler" $srcdir/configure $config_and_prefix
265         CC="$CCACHE $compiler"
266         export CC
267         ./timelimit $MAXTIME $srcdir/configure $config_and_prefix
268         cstatus=$?
269         if [ x"$cstatus" != x"0" ]; then
270                 if [ -f config.log ]; then
271                         echo "contents of config.log:"
272                         cat config.log
273                 fi
274                 if [ -f bin/config.log ]; then
275                         echo "contents of config.log:"
276                         cat bin/config.log
277                 fi
278         fi
279         echo "CONFIGURE STATUS: $cstatus"
280         return $cstatus;
281 }
282
283 ############################
284 # show the configure log
285 action_config_log() {
286     log_files="config.log bin/config.log"
287     for f in $log_files; do
288         if [ -f $f ]; then
289             echo "contents of config.log:"
290             cat $f
291             return 0;
292         fi
293     done
294     return 0
295 }
296
297 ############################
298 # show the config.h
299 action_config_header() {
300     hdr_files="config.h include/config.h bin/default/config.h bin/default/source4/include/config.h bin/default/source3/include/config.h"
301     for h in $hdr_files; do
302         if [ -f $h ]; then
303             echo "contents of $h:"
304             cat $h
305             return 0;
306         fi
307     done
308     return 0;
309 }
310
311 copy_dir() {
312         Tsrc=$1
313         Tdst=$2
314         rsync -a --delete $Tsrc/ $Tdst
315 }
316
317 s4selftest_create() {
318         lock_file "s4selftest.lck" || {
319                 return 1;
320         }
321
322         # we currently only need smbtorture
323         mkdir -p $s4selftest/source/bin
324         rsync -aL $builddir/bin/smbtorture.static $s4selftest/source/bin/smbtorture || {
325                 rm -rf $s4selftest/;
326                 unlock_file "s4selftest.lck";
327                 return 1;
328         }
329
330         unlock_file "s4selftest.lck"
331         return 0;
332
333         copy_dir $builddir/bin $s4selftest/source/bin || {
334                 rm -rf $s4selftest/;
335                 unlock_file "s4selftest.lck";
336                 return 1;
337         }
338
339         copy_dir $srcdir/setup $s4selftest/source/setup || {
340                 rm -rf $s4selftest/;
341                 unlock_file "s4selftest.lck";
342                 return 1;
343         }
344
345         copy_dir $srcdir/../testprogs $s4selftest/testprogs || {
346                 rm -rf $s4selftest/;
347                 unlock_file "s4selftest.lck";
348                 return 1;
349         }
350
351         copy_dir $srcdir/selftest $s4selftest/source/selftest || {
352                 rm -rf $s4selftest/;
353                 unlock_file "s4selftest.lck";
354                 return 1;
355         }
356
357         copy_dir $srcdir/script $s4selftest/source/script || {
358                 rm -rf $s4selftest/;
359                 unlock_file "s4selftest.lck";
360                 return 1;
361         }
362
363         mkdir -p $s4selftest/source/scripting || {
364                 rm -rf $s4selftest/;
365                 unlock_file "s4selftest.lck";
366                 return 1;
367         }
368
369         unlock_file "s4selftest.lck"
370 }
371
372 s4selftest_update() {
373         lock_file "s4selftest.lck" || {
374                 return 1;
375         }
376
377         echo tmp.$tree.$compiler.$$ >tmp.dirname
378         tempdir=`cut -b1-32 tmp.dirname`
379         rm -f tmp.dirname
380
381         copy_dir $s4selftest $tempdir || {
382                 rm -rf $tempdir;
383                 unlock_file "s4selftest.lck";
384                 return 1;
385         }
386
387         rm -rf $s4selftest.$tree.$compiler
388         mv $tempdir $s4selftest.$tree.$compiler
389
390         unlock_file "s4selftest.lck"
391 }
392
393 ############################
394 # build the tree
395 action_build() {
396         case "$tree" in
397         samba_4*)
398                 do_make everything
399                 bstatus=$?
400                 if test x"$bstatus" != x"0"; then
401                         # the 2nd 'make everything' is to work around a bug
402                         # in netbsd make. 
403                         do_make everything
404                         bstatus=$?
405                 fi
406
407                 if test x"$bstatus" != x"0"; then
408                         do_make testsuite
409                         bstatus=$?
410                 fi
411
412                 if test x"$bstatus" = x"0"; then
413                         s4selftest_create
414                 fi
415
416                 ;;
417         samba_3*)
418                 do_make everything torture
419                 bstatus=$?
420                 ;;
421         *)
422                 do_make all
423                 bstatus=$?
424                 ;;
425         esac
426
427         echo "BUILD STATUS: $bstatus"
428
429         return $bstatus
430 }
431
432 ############################
433 # show static analysis results
434 action_cc_checker() {
435
436         # default to passing the cc_checker
437         cccstatus=0
438
439         if [ -f ibm_checker.out ]; then
440                 cat ibm_checker.out
441                 cccstatus=`cat ibm_checker.out | grep '^\-\- ' | wc -l`
442         fi
443
444         echo "CC_CHECKER STATUS: $cccstatus"
445         return $cccstatus;      
446 }
447
448 ############################
449 # install the tree
450 action_install() {
451         if [ -d $prefix ]; then
452                 if [ "$noclean" != "yes" ]; then
453                     rm -rf $prefix
454                 fi
455         fi
456
457         do_make install
458         istatus=$?
459         echo "INSTALL STATUS: $istatus"
460         return $istatus;
461 }
462
463 ############################
464 # test the tree
465 action_test_samba() {
466         do_make test
467         totalstatus=$?
468         # if we produced a test summary then show it
469         [ -f st/summary ] && {
470             echo "TEST SUMMARY"
471             cat st/summary
472         }
473         return "$totalstatus"
474 }
475
476 action_test_generic() {
477         CC="$compiler"
478         export CC
479         do_make installcheck
480         totalstatus=$?
481         echo "TEST STATUS: $totalstatus"
482         return "$totalstatus"
483 }
484
485 action_test_lorikeet_heimdal() {
486         CC="$compiler"
487         export CC
488         SOCKET_WRAPPER_DIR=`pwd`/sw
489         mkdir $SOCKET_WRAPPER_DIR
490         export SOCKET_WRAPPER_DIR
491         do_make check
492         totalstatus=$?
493         SOCKET_WRAPPER_DIR=
494         export SOCKET_WRAPPER_DIR
495         echo "TEST STATUS: $totalstatus"
496         return "$totalstatus"
497 }
498
499
500 #############################
501 # attempt some basic tests of functionaility
502 # starting as basic as possible, and getting incresingly complex
503
504 action_test() {
505         # Samba needs crufty code of its own for backward
506         # compatiblity.  I think a better way to do this in the future
507         # is to just call 'make installcheck'.
508         case "$tree" in
509         samba*|smb-build|pidl)
510             action_test_samba
511             ;;
512         lorikeet-heimdal*)
513             action_test_lorikeet_heimdal
514             ;;
515         *)
516             action_test_generic
517             ;;
518         esac
519 }
520
521 ###########################
522 # do a test build of a particular tree
523 test_tree() {
524         tree=$1
525         source=$2
526         compiler="$3"
527         shift
528         shift
529         shift
530         if [ "$compiler" = "gcc" ] && [ "$tree" != "ccache" ] && ccache -V > /dev/null; then
531             CCACHE="ccache"
532             export CCACHE
533         else
534             CCACHE=""
535         fi
536
537         # limit our resource usage
538         ulimit -t $MAXTIME 2> /dev/null
539
540         # max mem size 100M
541         ulimit -m $MAXMEM 2> /dev/null
542
543         # max file size 100M
544         # darn, this affects sparse files too! disable it
545         # ulimit -f 100000 2> /dev/null
546
547         # try and limit the number of open files to 250. That means we'll discover
548         # fd leaks faster
549         ulimit -n 250 2> /dev/null
550
551         # Keep stuff private
552         umask 077
553
554         if [ -z "$test_root" ]; then
555                 test_root=`pwd`
556         fi
557
558         log="build.$tree.$host.$compiler.log"
559         err="build.$tree.$host.$compiler.err"
560         sum="build.$tree.$host.$compiler.sum"
561         lck="build.$tree.lck"
562         srcdir="$test_root/$tree/$source"
563
564         lock_file "$lck" || {
565                 return
566         }
567
568         # work out what other trees this package depends on
569         deptrees=""
570         case "$tree" in
571             samba-gtk)
572                 deptrees="samba_4_0_test"
573                 ;;
574         esac
575
576         scm=`choose_scm "$tree"`
577
578         # pull the entries, if any
579         if fetch_revinfo "$tree" "$scm"; then
580             for d in $deptrees; do
581                 dscm=`choose_scm "$d"`
582                 if [ -f "$test_root/$d.$dscm" ]; then
583                     if [ "$d" != "$tree" ]; then
584                         cat "$test_root/$d.$dscm" >> $test_root/$tree.$scm
585                     fi
586                 fi
587             done
588             rm -f $test_root/$tree.$compiler.$scm.old
589             mv $test_root/$tree.$compiler.$scm $test_root/$tree.$compiler.$scm.old
590             cp $test_root/$tree.$scm $test_root/$tree.$compiler.$scm
591             if cmp $test_root/$tree.$compiler.$scm $test_root/$tree.$compiler.$scm.old > /dev/null; then
592                 echo "skip: $tree.$compiler nothing changed in $scm"
593                 cd $test_root
594                 send_logs_skip "$log" "$err"
595                 unlock_file "$lck"
596                 return
597             fi
598         fi
599
600         # pull the tree
601         fetch_tree "$tree" || {
602             cd $test_root
603             unlock_file "$lck"
604             return
605         }
606
607         if [ ! -x $srcdir/configure ] && [ "$tree" != "pidl" ]; then
608                 echo "skip: $tree.$compiler configure not present, try again next time!"
609                 cd $test_root
610                 unlock_file "$lck"
611                 return
612         fi
613
614         echo "Starting build of $tree.$compiler in process $$ at `date`"
615
616         case "$tree" in
617             libreplace)
618                 builddir="$test_root/tmp.$tree.$compiler"
619                 usingtmpbuild=1
620                 if [ -d $builddir ]; then
621                     rm -rf $builddir
622                 fi
623                 mkdir -p $builddir
624                 export builddir
625             ;;
626             *)
627                 builddir=$srcdir
628                 usingtmpbuild=0
629                 export builddir
630             ;;
631         esac
632         
633         if [ ! x$USER = x"" ]; then
634             whoami=$USER
635         else 
636             if [ ! x$LOGNAME = x"" ]; then
637                 whoami=$LOGNAME
638             else
639                 whoami=build
640             fi
641         fi
642
643         prefix="$test_root/prefix/$tree.$compiler"
644         mkdir -p "$prefix"
645
646         s4selftest=$test_root/s4selftest
647         export s4selftest
648
649         sw_config=$config
650
651         case "$tree" in
652         lorikeet-heimdal)
653                 sw_config="$config --enable-socket-wrapper"
654                 ;;
655         samba_4*)
656                 sw_config="$config --enable-socket-wrapper"
657                 sw_config="$sw_config --enable-nss-wrapper"
658                 sw_config="$sw_config --enable-uid-wrapper"
659                 ;;
660         samba_3*)
661                 sw_config="$config --enable-socket-wrapper"
662                 sw_config="$sw_config --enable-nss-wrapper"
663                 s4selftest_update "$tree" "$compiler" && {
664                         t="$s4selftest.$tree.$compiler/source"
665                         #sw_config="$sw_config --with-samba4srcdir=$t"
666                         t="$t/bin/smbtorture"
667                         sw_config="$sw_config --with-smbtorture4-path=$t"
668                 }
669                 ;;
670         samba-gtk)
671                 PKG_CONFIG_PATH="$test_root/prefix/samba_4_0_test.$compiler/lib/pkgconfig"
672                 export PKG_CONFIG_PATH
673                 ;;
674         *)
675                 testsuite=testsuite
676                 ;;
677         esac
678
679         if [ "$LCOV_REPORT" = "yes" ]; then
680             GCOV_FLAGS="--coverage"
681             CFLAGS="$CFLAGS $GCOV_FLAGS" 
682             LDFLAGS="$LDFLAGS $GCOV_FLAGS" 
683             export CFLAGS LDFLAGS
684         fi
685
686         config_and_prefix="$sw_config --prefix=$prefix"
687
688         # see if we need to rebuild
689         sum_tree $test_root $tree $sum $scm
690         echo "CFLAGS=$CFLAGS $config_and_prefix" >> $sum
691
692         if cmp "$sum" "$sum.old" > /dev/null; then
693                 echo "skip: $tree.$compiler nothing changed"
694                 cd $test_root
695                 send_logs_skip "$log" "$err"
696                 unlock_file "$lck"
697                 echo "Ending build of $tree.$compiler in process $$ at `date`"
698                 return
699         fi
700
701         # we do need to rebuild - save the old sum
702         /bin/rm -f $sum.old
703         mv $sum $sum.old
704
705         actions="$*"
706         
707         if [ "$actions" = "" ]; then
708             actions="configure config_log config_header build install test"
709         fi
710
711         # start the build
712         (
713         {
714                 # we all want to be able to read the output...
715                 LANG=C
716                 export LANG
717
718                 uname -a
719
720                 echo ""
721                 echo "build_test          : $build_test_id"
722                 echo "build_test.fns      : $build_test_fns_id"
723                 echo "local settings file : $build_test_settings_local_file"
724                 echo "local functions file: $build_test_fns_local_file"
725                 echo "used .fns file      : $build_test_used_fns_file"
726                 echo ""
727
728                 # we need to be able to see if a build farm machine is accumulating
729                 # stuck processes. We do this in two ways, as we don't know what style
730                 # of ps it will have
731                 ps xfuw 2> /dev/null
732                 ps -fu $USER 2> /dev/null
733
734                 echo "building $tree with CC=$compiler on $host at "`date`
735                 echo "builddir=$builddir"
736                 echo "prefix=$prefix"
737
738                 echo "Showing limits"
739                 ulimit -a 2> /dev/null
740
741                 # build the timelimit utility
742                 echo "Building timelimit"
743                 mkdir -p $builddir
744                 $compiler $TIMELIMIT_FLAGS -o $builddir/timelimit $test_root/timelimit.c || exit 1
745
746                 # the following is for non-samba builds only
747                 if [ "$scm" = "svn" -a -r $test_root/$tree.svn ]; then
748                   h_rev=`grep 'Revision: ' $test_root/$tree.svn | cut -d ':' -f2 | cut -d ' ' -f2 | sed 1q`
749                   if [ -n "$h_rev" ]; then
750                         echo "HIGHEST SVN REVISION: $h_rev"
751                   fi
752                   rev=`grep 'Last Changed Rev: ' $test_root/$tree.svn | cut -d ':' -f2 | cut -d ' ' -f2 | sed 1q`
753                   if [ -n "$rev" ]; then
754                         echo "BUILD REVISION: $rev"
755                   fi
756                 elif [ "$scm" = "git" -a -r $test_root/$tree.git ]; then
757                   csha1=`cat $test_root/$tree.git |head -3 | tail -1`
758                   if [ -n "$csha1" ]; then
759                     echo "BUILD COMMIT REVISION: $csha1"
760                   fi
761                   cdate=`cat $test_root/$tree.git |head -4 | tail -1`
762                   if [ -n "$cdate" ]; then
763                     echo "BUILD COMMIT DATE: $cdate"
764                   fi
765                   ctime=`cat $test_root/$tree.git |head -2 | tail -1`
766                   if [ -n "$ctime" ]; then
767                     echo "BUILD COMMIT TIME: $ctime"
768                   fi
769                 fi
770
771                 if [ "$tree" = "pidl" ] 
772                 then
773                         cd $builddir
774                         perl ./Makefile.PL "$prefix"
775                 fi
776
777                 for action in $actions; do
778
779                     echo Running action $action
780
781                     date
782
783                     cd $builddir || exit 1
784                     export srcdir
785                     df .
786                     mount
787                     vmstat
788
789                     ( action_$action )
790                     action_status=$?
791
792                     df .
793
794                     if [ $action_status != 0 ]; then
795                         echo "ACTION FAILED: $action";
796                     else
797                         echo "ACTION PASSED: $action";
798                     fi
799                     
800                     if [ $action_status != 0 ]; then 
801                         break;
802                     fi
803
804                 done
805
806                 if [ "$LCOV_REPORT" = "yes" ]; then
807                     case "$tree" in
808                         lorikeet-heimdal*)
809                             lcov --directory $builddir --capture --output-file $builddir/$tree.lcov.info
810                             ;;
811                         samba_3_master*)
812                             lcov --base-directory $builddir --directory $builddir/.. --capture --output-file $builddir/$tree.lcov.info
813                             ;;
814                         samba_4*)
815                             # ugly hack for s4, as lcov is otherwise not able to find 
816                             # these files
817                             rm -f heimdal/lib/*/{lex,parse,sel-lex}.{gcda,gcno}
818                             lcov --base-directory $builddir --directory $builddir/.. --capture --output-file $builddir/$tree.lcov.info
819                             ;;
820                         *)
821                             lcov --base-directory $builddir --directory $builddir --capture --output-file $builddir/$tree.lcov.info
822                             ;;
823                     esac
824                     genhtml -o $builddir/coverage $builddir/$tree.lcov.info
825                 fi
826
827                 if [ "$noclean" = "yes" ]; then
828                     echo cleanup skipped!
829                 else
830                     echo cleaning up
831                     do_make clean
832                 fi
833                 date
834         } 3>&2 2>&1 1>&3 | tee "$err"
835         ) > "$log" 2>&1
836         # be aware the above channel swap may sometimes result in unordered
837         # stdout/stderr merge
838
839         if [ "$LCOV_REPORT" = "yes" ]; then
840             chmod u=rwX,g=rX,o=rX -R $builddir/coverage
841             rsync -rct -q --password-file=.password -z --timeout=200 \
842                 $builddir/coverage/ $host@build.samba.org::lcov_data/$host/$tree/
843         fi
844
845         cd $test_root
846
847         /bin/rm -rf $prefix
848         if [ "$usingtmpbuild" = "1" ]; then
849             if [ "$noclean" = "yes" ]; then
850                 echo builddir cleanup skipped!
851             else
852                 /bin/rm -rf $builddir
853             fi
854         fi
855         # send the logs to the master site
856         send_logs "$log" "$err"
857
858         # cleanup
859         echo "Ending build of $tree.$compiler in process $$ at `date`"
860         unlock_file "$lck"
861 }
862
863 #########################################################
864 # if you want to build only one project at a time
865 # add 'global_lock' after 'per_run_hook' and
866 # 'global_unlock' to the end of the file
867 global_lock() {
868     lock_file "global.lck" || {
869         exit 0
870     }
871 }
872 global_unlock() {
873     unlock_file "global.lck"
874 }
875
876 #########################################################
877 # enable this on a per host basis only when needed please
878 # (at least for the moment)
879 kill_old_processes() {
880     # this should work on systems with linux like ps
881     (ps uxfw | grep /build | grep -v grep | egrep 'Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec' | awk '{print $2}' | xargs kill -9) 2> /dev/null
882     # and this should work on sysv style ps
883     (ps -fu $USER | grep /build | grep -v grep | egrep 'Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec' | awk '{print $2}' | xargs kill -9) 2> /dev/null
884 }
885
886 delete_old_tree() {
887         otree=$1
888
889         test -z "$otree" && return 0;
890
891         rm -rf $otree
892         rm -rf $otree.svn
893         rm -rf $otree.*.svn
894         rm -rf $otree.git
895         rm -rf $otree.*.git
896         rm -rf s4selftest.$otree.*
897         rm -rf build.$otree.*
898 }
899
900 # this is a special fn that allows us to add a "special" hook to the build
901 # farm that we want to do to the build farm. never leave it empty. instead,
902 # use ":" as the fn body.
903 per_run_hook() {
904     # kill old processes on systems with a known problem
905     case $host in
906         nohost)
907             echo "just a placeholder";
908             ;;
909         tridge)
910             kill_old_processes
911             ;;
912         deckchair)
913             rm -f deckchair.fns
914             ;;
915     esac
916     # trim the log if too large
917     if [ "`wc -c < build.log`" -gt 2000000 ]; then
918         rm -f build.log
919     fi
920
921     delete_old_tree "samba_3_2"
922     delete_old_tree "samba_3_2_test"
923     delete_old_tree "samba4"
924     delete_old_tree "samba_3_X_test"
925     delete_old_tree "samba_3_X_devel"
926 }
927
928
929 ######################################################
930 # main code that is run on each call to the build code
931 rsync --timeout=200 -q -az build.samba.org::build_farm/*.c .
932
933
934 # build.log can grow to an excessive size, trim it beyond 50M
935 if [ -f build.log ]; then
936   find build.log -size +100000 -exec /bin/rm '{}' \;
937 fi
938